/*********************************************
Project : Commande du Vigipark (TP1)
Version : 1
Mise  jour: 28/10/2010
Author  : Philippe Mariano
Company : LYCEE Pierre Emile MARTIN
Comments: Le bras est  l'arrt et en position haute
L'appui sur UHF lance le cycle:
descente -> remontee -> arret
Cible : Systme VIGIPARK
Chip type           : ATMEGA8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/
// -----------------------------------------------------------------------------------------------------
// Bibliothques
// -----------------------------------------------------------------------------------------------------
#include <mega8535.h>
// -----------------------------------------------------------------------------------------------------
// Dclarations
#define Arret	    0
#define Monter 	    1
#define Descendre   2
// -----------------------------------------------------------------------------------------------------

// =====================================================================================================
// Programme principal
// =====================================================================================================
void main(void)
{  // Dbut prog principal
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------
// type 	    nom              		        Description
// -----------------------------------------------------------------------------------------------------
unsigned char BP_UHF, CAPT_HAUT, CAPT_BAS;   // Etat du bouton-poussoir UHF et des capteurs HAUT, BAS
unsigned char Moteur;                        // Commande du moteur
unsigned char Etat;                          // Etat du graphe
// -----------------------------------------------------------------------------------------------------
// Initialisations des Ports d'E/S
// -----------------------------------------------------------------------------------------------------
DDRA = 0x00 ;
DDRC = 0X1F;
// -----------------------------------------------------------------------------------------------------
// Initialisation du graphe et des sorties
// -----------------------------------------------------------------------------------------------------
Etat = 0; Moteur = 0;
// =====================================================================================================
// Boucle principale
// =====================================================================================================
while(1)
 {
//-------------------------------------------------------------------------------------------------------
// Lecture des entres
//-------------------------------------------------------------------------------------------------------
 BP_UHF = (PINA & 0x10);
 CAPT_HAUT = (PINA & 0x04);
 CAPT_BAS = (PINA & 0x08);
//-------------------------------------------------------------------------------------------------------
// Traitement
//-------------------------------------------------------------------------------------------------------
 switch (Etat)
  {                         // Arret
   case Arret: Moteur = 0;
      if (BP_UHF == 0x10)	Etat = Descendre;
            else Etat = Arret;
   break;
                           // Descendre
   case Descendre: Moteur = ?;                              // <-  complter
      if (CAPT_BAS == 0x??)  Etat=???;                      // <-  complter
            else Etat = ???;                                // <-  complter
   break;
                           // Monter
   case Monter: Moteur = ?;                                 // <-  complter
      if (CAPT_HAUT == 0x??) Etat=???;	                    // <-  complter
            else Etat = ???;                                // <-  complter
   break;

   default : Etat = 0;
  }
 //-------------------------------------------------------------------------------------------------------
// Ecriture des sorties
//-------------------------------------------------------------------------------------------------------
   PORTC = Moteur;
};// Fin while
 //-------------------------------------------------------------------------------------------------------
}// Fin prog principal
// ======================================================================================================